



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>jQuery 1.4.4 中 function( window, undefined ) 写法原因</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">jQuery 1.4.4 中 function( window, undefined ) 写法原因</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 19:40:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>读 jQuery 1.4.4 版本代码的时候，发现下面的写法：</p>
<p>(function( window, undefined )</p>
<p>{</p>
<p>... // code goes here</p>
<p>})(window);</p>
<p>window 肯定是没问题， 表示 BOM 浏览器对象模型中的 window 对象。但是这里为什么会有一个名为 undefined 的形参呢？起初的时候很不理解。去技术群请教了一下，才真正理解了这里的原因。</p>
<p>原来，Javascript 中的 undefined 并不是作为关键字（全部<a href="http://aptana.com/reference/html/api/JSKeywords.index.html" rel="external nofollow noreferrer">Javascript关键字列表</a>）出现的。因此可以允许用户对其赋值。例如：</p>
<p>var undefined = 'myValue';</p>
<p>如此一来，假如 jQuery 中使用下面的写法：</p>
<p>(function( window ) {</p>
<p>... // code goes here</p>
<p>})(window);</p>
<p>必然造成中间代码里的 undefined 遭到污染。因为在默认情况下，对于一个未定义的变量，它的值应该是 undefined，假如用户使用形如</p>
<p>var undefined = 'myValue';&nbsp;// 或者window.undefined = 'myValue';</p>
<p>的代码进行赋值，那么，jQuery 中的 undefined 的值就变成了用户指定的值（这里是字符串 &lsquo;myValue&rsquo;）。这样会造成 jQuery 内部异常。</p>
<p>而 jQuery 采用的这种写法，就很好的避免了这个问题。在执行匿名函数的时候，只传递一个参数 window, 而不传递 undefined，那么函数体中的 undefined 局部变量的值，刚好就是 undefined. 甚为巧妙啊。</p>
<p>比较以下几段代码：</p>
<p>&lt;script type="text/javascript"&gt;<br />(function(window, undefined){<br />alert(undefined);<br />})(window);<br />&lt;/script&gt;</p>
<p>&lt;script type="text/javascript"&gt;<br />var undefined ="myValue";<br />(function(window){<br />alert(undefined);<br />})(window);<br />&lt;/script&gt;</p>
<p>&lt;script type="text/javascript"&gt;<br />var undefined ="myValue";<br />(function(window, undefined){<br />alert(undefined);<br />})(window);<br />&lt;/script&gt;</p>
<p>&lt;script type="text/javascript"&gt;<br />var undefined ="myValue";<br />window.undefined ="myValue2";<br />(function(window){<br />alert(undefined);<br />})(window);<br />&lt;/script&gt;</p>
<p>&lt;script type="text/javascript"&gt;<br />var undefined ="myValue";<br />window.undefined ="myValue2";<br />(function(window, undefined){<br />alert(undefined);<br />})(window);<br />&lt;/script&gt;</p>
<p>Answer：undefined myvalue undefined myvalue2 undefined</p>
<p>原文地址：<a href="http://www.fising.cn/?p=127" rel="external nofollow noreferrer">http://www.fising.cn/?p=127</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mzx6qk.html">基于jsp&plus;servlet图书管理系统之后台万能模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/495gmo0q.html">&lbrack;ASP&period;NET MVC 小牛之路&rsqb;15 - Model Binding</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e37nmq.html">PDF2</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv3jv18.html">一个比较有意思的C语言问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8expkkq.html">JavaScript函数劫持</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql07eeq.html">LUA语言注意点归集</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z13gl19.html">C语言深入学习系列 - 字节对齐&amp;amp&semi;内存管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmwy109.html">poj 2262 Goldbach&amp;&num;39&semi;s Conjecture&lpar;素数筛选法&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvod61q.html">HDU 1176 免费馅饼（数字三角形）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9500onm8.html">Cytoscape画图初探</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjj6p38.html">使用sqlnet&period;ora限制IP访问</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo45e1q.html">DocNan博文目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1yorjq.html">java中强大的免费的集成开发环境&lpar;IDE&rpar;eclipse的使用技巧及注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25xr03q.html">黑苹果 技嘉 B250M-DS3H-CF i57500 HD630 EFI引导驱动发布</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvyn5j8.html">BZOJ&period;4337&period;&lbrack;BJOI2015&rsqb;树的同构&lpar;树哈希&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv23jyy9.html">github管理项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jw6njq.html">Oracle系列&lpar;一&rpar;： Oracle数据恢复</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ore0e8.html">一、TCP扫描技术</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m235r2q.html">linux命令学习之：systemctl</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1y13e9.html">ADO&period;NET 4&period;5中的异步与流特性</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlmxev69.html">Design Pattern Explained 读书笔记二&mdash;&mdash;设计模式序言</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v17w38.html">2015北京网络赛 A题 The Cats&amp;&num;39&semi; Feeding Spots 暴力</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xnxg08.html">用普通IO驱动LCD的控制方法-松瀚汇编源程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zdzl49.html">WM&lowbar;VSCROLL</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmxm2z9.html">Nginx &plus; Tomcat &plus; Session</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnx2rrq.html">获取设置dom属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjvpdd9.html">zend studio快捷模板 开发工具之zend studio一些配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v12g48.html">Overview &amp;amp&semi; Change Log</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdzo5y8.html">void及void指针含义的深刻解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmx5g79.html">创建eclipse新的workspace并设置workspace共享配置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
